<?php
/*
  Plugin Name: Editor Cleanup For Elementor [ecfe]
  Description: mu-plugin automatically installed by Editor CLeanup For Elementor
  Version: 0.0.2
  Plugin URI: https://freesoul-deactivate-plugins.com/
  Author: Jose Mortellaro
  Author URI: https://josemortellaro.com/
  License: GPLv2
*/

defined( 'ABSPATH' ) || exit; // Exit if accessed directly
define( 'FDP_ECFE_MU_VERSION','0.0.2' );

if( isset( $_GET['action'] ) && 'elementor' === $_GET['action'] ){
  add_filter( 'fdp_backend_plugins',function( $plugins ){
    return eos_dp_ecfe_plugins( $plugins,'outer' );
  } );
}
elseif( isset( $_GET['elementor-preview'] ) && absint( $_GET['elementor-preview'] ) > 0 ){
  add_filter( 'fdp_frontend_plugins',function( $plugins ){
    return eos_dp_ecfe_plugins( $plugins,'inner' );
  } );
}
elseif( isset( $_SERVER['REQUEST_URI'] ) && false !== strpos( $_SERVER['REQUEST_URI'],'wp-json/elementor' ) ){
  add_filter( 'fdp_frontend_plugins',function( $plugins ){
    return eos_dp_ecfe_plugins( $plugins,'loading' );
  } );
}

add_filter( 'fdp_ajax_plugins',function( $plugins ){
  $elementor_actions = array(
    'elementor_ajax'
  );
  if( isset( $_REQUEST['action'] ) && in_array( sanitize_text_field( $_REQUEST['action'] ),$elementor_actions ) ){
    return eos_dp_ecfe_plugins( $plugins,'loading' );
  }
  return $plugins;
} );

add_filter( 'fdp_ajax_plugins',function( $plugins ){
  if( isset( $_REQUEST['action'] ) && in_array( sanitize_text_field( $_REQUEST['action'] ),array( 'eos_dp_save_elementor_outer_settings','eos_dp_save_elementor_inner_settings','eos_dp_save_elementor_loading_settings' ) ) ){
    return array_merge( array( 'elementor/elementor.php' ),fdp_ecfe_plugins( $plugins ) );
  }
  return $plugins;
} );

function eos_dp_ecfe_plugins( $plugins,$page ){
  $opts = eos_dp_get_option( 'fdp_elementor' );
  $elementor_plugins = isset( $opts[$page] ) ? $opts[$page] : array();
  $fdp_plugins = fdp_ecfe_plugins( $plugins );
  $elementor_plugins = $elementor_plugins && is_array( $elementor_plugins ) ? array_merge( $elementor_plugins,$fdp_plugins ) : $fdp_plugins;
  foreach( $elementor_plugins as $plugin ){
    if( in_array( $plugin,$plugins ) || in_array( $plugin,$fdp_plugins ) ){
      unset( $plugins[array_search( $plugin,$plugins )] );
    }
  }
  return array_values( $plugins );
}

function fdp_ecfe_plugins( $plugins ){
  $arr = array(
    'freesoul-deactivate-plugins/freesoul-deactivate-plugins.php',
    'editor-cleanup-for-elementor/editor-cleanup-for-elementor.php'
  );
  if( in_array( 'freesoul-deactivate-plugins-pro/freesoul-deactivate-plugins-pro.php',$plugins ) ){
    $arr[] = 'freesoul-deactivate-plugins-pro/freesoul-deactivate-plugins-pro.php';
  }
  return $arr;
}
